Index: issm/trunk/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp	(revision 13975)
@@ -21,5 +21,4 @@
 }
 
-	
 void InputUpdateFromVectorDakotax( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double* vector, int name, int type){
 
@@ -28,5 +27,5 @@
 	/*Update elements, nodes, loads and materials from inputs: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromVectorDakota(vector,name,type);
 	}
@@ -46,10 +45,10 @@
 
 void InputUpdateFromVectorDakotax( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,int* vector, int name, int type){
-	
+
 	int i;
 
 	/*Update elements, nodes, loads and materials from inputs: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromVectorDakota(vector,name,type);
 	}
@@ -74,5 +73,5 @@
 	/*Update elements, nodes, loads and materials from inputs: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromVectorDakota(vector,name,type);
 	}
Index: issm/trunk/src/c/modules/InputUpdateFromVectorx/InputUpdateFromVectorx.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromVectorx/InputUpdateFromVectorx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputUpdateFromVectorx/InputUpdateFromVectorx.cpp	(revision 13975)
@@ -21,5 +21,4 @@
 }
 
-	
 void InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* vector, int name, int type){
 
@@ -28,5 +27,5 @@
 	/*Update elements, nodes, loads and materials from inputs: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromVector(vector,name,type);
 	}
@@ -46,10 +45,10 @@
 
 void InputUpdateFromVectorx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,int* vector, int name, int type){
-	
+
 	int i;
 
 	/*Update elements, nodes, loads and materials from inputs: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromVector(vector,name,type);
 	}
@@ -74,5 +73,5 @@
 	/*Update elements, nodes, loads and materials from inputs: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromVector(vector,name,type);
 	}
Index: issm/trunk/src/c/modules/InterpFromGridToMeshx/InterpFromGridToMeshx.cpp
===================================================================
--- issm/trunk/src/c/modules/InterpFromGridToMeshx/InterpFromGridToMeshx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InterpFromGridToMeshx/InterpFromGridToMeshx.cpp	(revision 13975)
@@ -21,9 +21,8 @@
 	/*output: */
 	SeqVec<IssmPDouble>* data_mesh=NULL;
-	
+
 	/*Intermediary*/
 	double* x=NULL;
 	double* y=NULL;
-	double  x_grid,y_grid;
 	int     i;
 
@@ -312,5 +311,5 @@
 	_assert_(x2>x1 && y2>y1);
 	_assert_(x<=x2 && x>=x1 && y<=y2 && y>=y1);
-	
+
 	double xm=(x2-x1)/2;
 	double ym=(y2-y1)/2;
Index: issm/trunk/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dx.cpp
===================================================================
--- issm/trunk/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dx.cpp	(revision 13975)
@@ -14,15 +14,12 @@
 			double* x_prime, double* y_prime, int nods_prime,
 			double* default_values,int num_default_values,Contour<IssmPDouble>** contours,int numcontours){
-	
+
 	/*Output*/
 	SeqVec<IssmPDouble>* data_prime=NULL;
 
 	/*Intermediary*/
-	int    i,j;
+	int    i;
 	int    interpolation_type;
 	bool   debug;
-	double area;
-	double area_1,area_2,area_3;
-	double data_value;
 	double xmin,xmax;
 	double ymin,ymax;
Index: issm/trunk/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.cpp
===================================================================
--- issm/trunk/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.cpp	(revision 13975)
@@ -15,5 +15,5 @@
 int InterpFromMeshToMesh2dx(double** pdata_interp,int* index_data,double* x_data,double* y_data,int nods_data,int nels_data,
 			double* data,int M_data,int N_data,double* x_interp,double* y_interp,int N_interp,Options* options){
-	
+
 	/*Output*/
 	double* data_interp=NULL;
@@ -25,10 +25,9 @@
 	R2     r;
 	I2     I;
-	int    i,j,k;
+	int    i,j;
 	int    it;
 	int    i0,i1,i2;
 	double areacoord[3];
 	double aa,bb;
-	double data_value;
 	Icoor2 dete[3];
 
Index: issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 13975)
@@ -11,20 +11,16 @@
 
 void IoModelToConstraintsx(Constraints* constraints,IoModel* iomodel,int vector_enum,int analysis_type){
-	
 
 	/*intermediary: */
 	int     i,j;
-	bool    transient     = false;
-
-	FILE   *fid           = NULL;
-	int     code          = 0;
-	int     vector_layout = 0;
-	int     counter;
-	int     nods;
-	IssmDouble* times=NULL;
-	IssmDouble* values=NULL;
-	bool    spcpresent=false;
-	int     count=0;
-	int     numberofvertices;
+	bool        transient        = false;
+	FILE       *fid              = NULL;
+	int         code             = 0;
+	int         vector_layout    = 0;
+	IssmDouble *times            = NULL;
+	IssmDouble *values           = NULL;
+	bool        spcpresent       = false;
+	int         count            = 0;
+	int         numberofvertices;
 
 	/*variables being fetched: */
@@ -48,8 +44,8 @@
 		/*static: just create Constraints objects*/
 		count=0;
-	
+
 		/*Create Constraints from x,y,z: */
 		for (i=0;i<numberofvertices;i++){
-			
+
 			/*keep only this partition's nodes:*/
 			if((iomodel->my_vertices[i])){
@@ -78,5 +74,5 @@
 		/*Create constraints from x,y,z: */
 		for (i=0;i<numberofvertices;i++){
-			
+
 			/*keep only this partition's nodes:*/
 			if((iomodel->my_vertices[i])){
Index: issm/trunk/src/c/modules/Kml2Expx/Kml2Expx.cpp
===================================================================
--- issm/trunk/src/c/modules/Kml2Expx/Kml2Expx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Kml2Expx/Kml2Expx.cpp	(revision 13975)
@@ -25,5 +25,5 @@
 			 int sgn,double cm,double sp){
 
-	int     i,iret=0;
+	int     iret=0;
 	double  *lat=NULL,*lon=NULL;
 
@@ -69,3 +69,2 @@
 	return(iret);
 }
-
Index: issm/trunk/src/c/modules/Krigingx/pKrigingx.cpp
===================================================================
--- issm/trunk/src/c/modules/Krigingx/pKrigingx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Krigingx/pKrigingx.cpp	(revision 13975)
@@ -14,6 +14,6 @@
 int pKrigingx(double** ppredictions,double **perror,double* obs_x, double* obs_y, double* obs_list, int obs_length,double* x_interp,double* y_interp,int n_interp,Options* options){
 
-	extern int num_procs;
-	extern int my_rank;
+	int num_procs;
+	int my_rank;
 
 	/*output*/
@@ -27,4 +27,8 @@
 	Variogram    *variogram    = NULL;
 	Observations *observations = NULL;
+
+	/*Get my_rank: */
+	my_rank=IssmComm::GetRank();
+	num_procs=IssmComm::GetSize();
 
 	/*Get some Options*/
@@ -64,6 +68,6 @@
 		double *sumpredictions =xNew<double>(n_interp);
 		double *sumerror       =xNew<double>(n_interp);
-		MPI_Allreduce(predictions,sumpredictions,n_interp,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD);
-		MPI_Allreduce(error,sumerror,n_interp,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD);
+		MPI_Allreduce(predictions,sumpredictions,n_interp,MPI_DOUBLE,MPI_SUM,IssmComm::GetComm());
+		MPI_Allreduce(error,sumerror,n_interp,MPI_DOUBLE,MPI_SUM,IssmComm::GetComm());
 		xDelete<double>(error); error=sumerror;
 		xDelete<double>(predictions); predictions=sumpredictions;
@@ -81,5 +85,5 @@
 #ifdef _HAVE_MPI_
 		double *sumpredictions =xNew<double>(n_interp);
-		MPI_Allreduce(predictions,sumpredictions,n_interp,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD);
+		MPI_Allreduce(predictions,sumpredictions,n_interp,MPI_DOUBLE,MPI_SUM,IssmComm::GetComm());
 		xDelete<double>(predictions); predictions=sumpredictions;
 #endif
@@ -98,5 +102,5 @@
 #ifdef _HAVE_MPI_
 		double *sumpredictions =xNew<double>(n_interp);
-		MPI_Allreduce(predictions,sumpredictions,n_interp,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD);
+		MPI_Allreduce(predictions,sumpredictions,n_interp,MPI_DOUBLE,MPI_SUM,IssmComm::GetComm());
 		xDelete<double>(predictions); predictions=sumpredictions;
 #endif
Index: issm/trunk/src/c/modules/MeshProfileIntersectionx/ElementSegment.cpp
===================================================================
--- issm/trunk/src/c/modules/MeshProfileIntersectionx/ElementSegment.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/MeshProfileIntersectionx/ElementSegment.cpp	(revision 13975)
@@ -3,5 +3,5 @@
 
 #include "./MeshProfileIntersectionx.h"
-		
+
 void ElementSegment(DataSet* segments_dataset,int el,double* xnodes,double* ynodes,double* xsegment,double* ysegment){
 
@@ -9,10 +9,8 @@
 	 * If they do, create a Segment object with the intersection, and add to segments_dataset dataset: */
 
-	int i;
-	double alpha;
 	double alpha1,alpha2;
 	double beta1,beta2;
 	double gamma1,gamma2;
-	
+
 	int    edge1,edge2,edge3;
 
@@ -21,5 +19,4 @@
 	double xfinal[2],yfinal[2];
 
-	
 	/*edge 1: */
 	xel[0]=xnodes[0];  yel[0]=ynodes[0]; xel[1]=xnodes[1];  yel[1]=ynodes[1];
@@ -41,5 +38,5 @@
 	}
 	else if(    ((edge1==IntersectEnum) && (edge2==IntersectEnum)) || ((edge2==IntersectEnum) && (edge3==IntersectEnum)) || ((edge3==IntersectEnum) && (edge1==IntersectEnum))   ){
-	
+
 		/*segment interscts 2 opposite edges of our triangle, at 2 segment coordinates, pick up the lowest (coord1) and highest (coord2): */
 		if((edge1==IntersectEnum) && (edge2==IntersectEnum)) {coord1=min(alpha1,beta1); coord2=max(alpha1,beta1);}
@@ -77,5 +74,5 @@
 			coord2=1.0;
 		}
-		
+
 		xfinal[0]=xsegment[0]+coord1*(xsegment[1]-xsegment[0]);
 		xfinal[1]=xsegment[0]+coord2*(xsegment[1]-xsegment[0]);
Index: issm/trunk/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.cpp
===================================================================
--- issm/trunk/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/MeshProfileIntersectionx/MeshProfileIntersectionx.cpp	(revision 13975)
@@ -7,5 +7,4 @@
 
 	int i,j,k;
-	int m,n;
 
 	/*Contour:*/
@@ -32,5 +31,5 @@
 	/*Loop through all contours: */
 	for (i=0;i<numcontours;i++){
-		
+
 		/*retrieve contour info: */
 		contouri=*(contours+i);
@@ -41,5 +40,5 @@
 		/*determine segmentsi and numsegsi for this contour and the mesh intersection: */
 		MeshSegmentsIntersection(&segmentsi,&numsegsi,index,x,y,nel,nods,xc,yc,numnodes);
-		
+
 		/*save segmentsi: */
 		allsegments[i]=segmentsi;
Index: issm/trunk/src/c/modules/ModelProcessorx/Autodiff/CreateParametersAutodiff.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Autodiff/CreateParametersAutodiff.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Autodiff/CreateParametersAutodiff.cpp	(revision 13975)
@@ -7,21 +7,29 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../classes/objects/objects.h"
+#include "../../../classes/classes.h"
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
+#include "../../Solverx/Solverx.h"
 #include "../ModelProcessorx.h"
 
 void CreateParametersAutodiff(Parameters** pparameters,IoModel* iomodel,int solution_type,int analysis_type){
-	
-	int         i,j;
+
+	int         i;
 	Parameters *parameters       = NULL;
 	bool        autodiff_analysis;
-	int*        dependents       = NULL;
-	int         num_dependents;
-	int*        independents       = NULL;
-	int         num_independents;
-	int         numberofvertices;
+	int         num_dependent_objects;
+	int         num_dep=0;
+	int*        names=NULL;
+	int*        types=NULL;
+	int         dummy;
+	char*       autodiff_driver=NULL;
+	int*        indices=NULL;
+	int         num_indices;
+
 	IssmDouble* xp=NULL;
-	
+	IssmDouble* xp_backup=NULL;
+	int         num_ind,local_num_ind;
+	DataSet*    dependent_objects=NULL;
+
 	/*Get parameters: */
 	parameters=*pparameters;
@@ -29,37 +37,99 @@
 	/*retrieve some parameters: */
 	iomodel->Constant(&autodiff_analysis,AutodiffIsautodiffEnum);
-	
+
 	if(autodiff_analysis){
 
-		iomodel->Constant(&num_independents,AutodiffNumIndependentsEnum);
-		iomodel->Constant(&num_dependents,AutodiffNumDependentsEnum);
-		iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
+		#ifdef _HAVE_ADOLC_
 
-		/*recover dependents: */
-		parameters->AddObject(iomodel->CopyConstantObject(AutodiffNumDependentsEnum));
-		if(num_dependents){
-			iomodel->FetchData(&dependents,NULL,&num_dependents,AutodiffDependentsEnum);
-			parameters->AddObject(new IntVecParam(AutodiffDependentsEnum,dependents,num_dependents));
+		/*Copy some parameters from IoModel to parameters dataset: */
+		parameters->AddObject(iomodel->CopyConstantObject(AutodiffKeepEnum));
+
+		/*retrieve driver: {{{*/
+		iomodel->Constant(&autodiff_driver,AutodiffDriverEnum);
+		parameters->AddObject(iomodel->CopyConstantObject(AutodiffDriverEnum));
+
+		if(strcmp(autodiff_driver,"fos_forward")==0){
+			parameters->AddObject(iomodel->CopyConstantObject(AutodiffFosForwardIndexEnum));
 		}
+		else if(strcmp(autodiff_driver,"fos_reverse")==0){
+			parameters->AddObject(iomodel->CopyConstantObject(AutodiffFosReverseIndexEnum));
+		}
+		else if(strcmp(autodiff_driver,"fov_forward")==0){
+			/*Retrieve list of indices: */
+			iomodel->FetchData(&indices,&num_indices,&dummy,AutodiffFovForwardIndicesEnum);
+			parameters->AddObject(new IntMatParam(AutodiffFovForwardIndicesEnum,indices,num_indices,1));
+			xDelete<int>(indices);
+		}
+		/*}}}*/
+		/*Deal with dependents first: {{{*/
+		iomodel->Constant(&num_dependent_objects,AutodiffNumDependentObjectsEnum);
+		dependent_objects=new DataSet();
+		num_dep=0;
 
-		/*recover independents: */
-		parameters->AddObject(iomodel->CopyConstantObject(AutodiffNumIndependentsEnum));
-		if(num_independents){
-			iomodel->FetchData(&independents,NULL,&num_independents,AutodiffIndependentsEnum);
-			parameters->AddObject(new IntVecParam(AutodiffIndependentsEnum,independents,num_independents));
+		if(num_dependent_objects){
+			iomodel->FetchData(&names,&dummy,&dummy,AutodiffDependentObjectNamesEnum);
+			iomodel->FetchData(&types,&dummy,&dummy,AutodiffDependentObjectTypesEnum);
+			iomodel->FetchData(&indices,&dummy,&dummy,AutodiffDependentObjectIndicesEnum);
 
-			/*Build state vector, value at which we compute our gradients of dependent variables in adolc: the xp vector  */
-			xp=xNew<IssmDouble>(num_independents*numberofvertices);
-			for(i=0;i<num_independents;i++){
-				IssmDouble* values=iomodel->data[independents[i]];
-				for(j=0;j<numberofvertices;j++){
-					xp[i*numberofvertices+j]=values[j];
-				}
+			for(i=0;i<num_dependent_objects;i++){
+				DependentObject* dep=new DependentObject(names[i],types[i],indices[i]);
+				dependent_objects->AddObject(dep);
+				num_dep+=dep->NumDependents();
 			}
-			parameters->AddObject(new DoubleVecParam(AutodiffXpEnum,xp,num_independents*numberofvertices));
+
+			/*Free ressources:*/
+			xDelete<int>(names);
+			xDelete<int>(types);
 		}
+		parameters->AddObject(new DataSetParam(AutodiffDependentObjectsEnum,dependent_objects));
+		parameters->AddObject(new IntParam(AutodiffNumDependentsEnum,num_dep));
 
-		/*Assign output pointer: */
-		*pparameters=parameters;
+		delete dependent_objects;
+		/*}}}*/
+		/*Deal with independents: {{{*/
+
+		/*Independents have already been recovered in iomodel->DeclareIndependents. Just do some more processing. 
+		 *In particular, figure out num_independents, and create the state vector xp, or size num_independents x 1 :*/
+		num_ind=0;
+		for(i=0;i<iomodel->independent_objects->Size();i++){
+			IndependentObject* ind=(IndependentObject*)iomodel->independent_objects->GetObjectByOffset(i);
+			num_ind+=ind->NumIndependents();
+		}
+		if(num_ind){
+			xp=xNew<IssmDouble>(num_ind);
+			xp_backup=xp;
+			for(i=0;i<iomodel->independent_objects->Size();i++){
+				IndependentObject* ind=(IndependentObject*)iomodel->independent_objects->GetObjectByOffset(i);
+				ind->FillIndependents(iomodel->data,xp);
+				local_num_ind=ind->NumIndependents(); xp=xp+local_num_ind;
+			}
+			xp=xp_backup; parameters->AddObject(new DoubleVecParam(AutodiffXpEnum,xp,num_ind));
+		}
+		parameters->AddObject(new IntParam(AutodiffNumIndependentsEnum,num_ind));
+
+		/*Don't forget to copy  iomodel->independent_objects to parameters: */
+		parameters->AddObject(new DataSetParam(AutodiffIndependentObjectsEnum,iomodel->independent_objects));
+		/*}}}*/
+
+		#endif
 	}
+
+	#ifdef _HAVE_ADOLC_
+		/*initialize a placeholder to store solver pointers: {{{*/
+		GenericParam<Adolc_edf> *theAdolcEDF_p=new GenericParam<Adolc_edf>(AdolcParamEnum);
+		theAdolcEDF_p->GetParameterValue().myEDF_for_solverx_p=reg_ext_fct(EDF_for_solverx);
+		// to save some space:
+		// we know we won't use adolc inside of  the solver:
+		theAdolcEDF_p->GetParameterValue().myEDF_for_solverx_p->nestedAdolc=false;
+		// the solution vector is just allocated and doesn't have a meaningfull prior value
+		theAdolcEDF_p->GetParameterValue().myEDF_for_solverx_p->dp_y_priorRequired=false;
+		// the solver wrapper makes sure the matrix and the right hand side don't change
+		theAdolcEDF_p->GetParameterValue().myEDF_for_solverx_p->dp_x_changes=false;
+		parameters->AddObject(theAdolcEDF_p);
+		/*}}}*/
+	#endif
+
+	/*Assign output pointer: */
+	*pparameters=parameters;
+
 }
Index: issm/trunk/src/c/modules/ModelProcessorx/Balancethickness/CreateConstraintsBalancethickness.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Balancethickness/CreateConstraintsBalancethickness.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Balancethickness/CreateConstraintsBalancethickness.cpp	(revision 13975)
@@ -10,14 +10,10 @@
 void	CreateConstraintsBalancethickness(Constraints** pconstraints, IoModel* iomodel){
 
+	/*Fetch parameters: */
 	int    stabilization;	
-	
-	/*Fetch parameters: */
 	iomodel->Constant(&stabilization,BalancethicknessStabilizationEnum);
 
-	/*Output*/
-	Constraints* constraints = NULL;
-
 	/*Recover pointer: */
-	constraints=*pconstraints;
+	Constraints* constraints=*pconstraints;
 
 	/*Create constraints if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/Balancethickness/CreateLoadsBalancethickness.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Balancethickness/CreateLoadsBalancethickness.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Balancethickness/CreateLoadsBalancethickness.cpp	(revision 13975)
@@ -14,5 +14,4 @@
 
 	/*Intermediary*/
-	int i;
 	int element;
 	int stabilization;
@@ -23,13 +22,10 @@
 	iomodel->Constant(&numberofedges,MeshNumberofedgesEnum);
 
-	/*Output*/
-	Loads*    loads    = NULL;
-
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
 	if(!loads) loads = new Loads();
-	
+
 	/*Loads only in DG*/
 	if (stabilization==3){
@@ -39,5 +35,5 @@
 
 		/*First load data:*/
-		for (i=0;i<numberofedges;i++){
+		for (int i=0;i<numberofedges;i++){
 
 			/*Get left and right elements*/
Index: issm/trunk/src/c/modules/ModelProcessorx/Balancethickness/CreateNodesBalancethickness.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Balancethickness/CreateNodesBalancethickness.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Balancethickness/CreateNodesBalancethickness.cpp	(revision 13975)
@@ -26,7 +26,4 @@
 	int    stabilization;
 
-	/*DataSets: */
-	Nodes*    nodes = NULL;
-
 	/*Fetch parameters: */
 	iomodel->Constant(&dim,MeshDimensionEnum);
@@ -36,5 +33,5 @@
 
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/BedSlope/CreateConstraintsBedSlope.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/BedSlope/CreateConstraintsBedSlope.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/BedSlope/CreateConstraintsBedSlope.cpp	(revision 13975)
@@ -13,9 +13,6 @@
 void	CreateConstraintsBedSlope(Constraints** pconstraints, IoModel* iomodel){
 
-	/*Output*/
-	Constraints* constraints = NULL;
-	
 	/*Recover pointer: */
-	constraints=*pconstraints;
+	Constraints* constraints=*pconstraints;
 
 	/*Create constraints if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/BedSlope/CreateLoadsBedSlope.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/BedSlope/CreateLoadsBedSlope.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/BedSlope/CreateLoadsBedSlope.cpp	(revision 13975)
@@ -13,9 +13,6 @@
 void	CreateLoadsBedSlope(Loads** ploads, IoModel* iomodel){
 
-	/*DataSet*/
-	Loads*    loads    = NULL;
-
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/BedSlope/CreateNodesBedSlope.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/BedSlope/CreateNodesBedSlope.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/BedSlope/CreateNodesBedSlope.cpp	(revision 13975)
@@ -18,21 +18,18 @@
 	int i;
 	bool continuous_galerkin=true;
-	int    numberofvertices;
-
-	/*DataSets: */
-	Nodes*    nodes = NULL;
 
 	/*Fetch parameters: */
+	int    numberofvertices;
 	iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
 
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
 	if(!nodes) nodes = new Nodes();
-	
+
 	/*Continuous Galerkin partition of nodes: */
 	NodesPartitioning(&iomodel->my_nodes,iomodel->my_elements,iomodel->my_vertices,iomodel,continuous_galerkin);
-	
+
 	/*First fetch data: */
 	iomodel->FetchData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
@@ -40,5 +37,5 @@
 	for (i=0;i<numberofvertices;i++){
 		if(iomodel->my_vertices[i]){
-			
+
 			/*Add node to nodes dataset: */
 			nodes->AddObject(new Node(iomodel->nodecounter+i+1,i,i+1,i,iomodel,BedSlopeAnalysisEnum));
@@ -49,5 +46,5 @@
 	/*Clean fetched data: */
 	iomodel->DeleteData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
-	
+
 	/*Assign output pointer: */
 	*pnodes=nodes;
Index: issm/trunk/src/c/modules/ModelProcessorx/Control/CreateParametersControl.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Control/CreateParametersControl.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Control/CreateParametersControl.cpp	(revision 13975)
@@ -13,6 +13,5 @@
 
 void CreateParametersControl(Parameters** pparameters,IoModel* iomodel,int solution_type,int analysis_type){
-	
-	int         i;
+
 	Parameters *parameters       = NULL;
 	bool        control_analysis;
@@ -21,8 +20,8 @@
 	int         num_cm_responses;
 	int        *control_type     = NULL;
-	IssmDouble     *cm_responses     = NULL;
-	IssmDouble     *cm_jump          = NULL;
-	IssmDouble     *optscal          = NULL;
-	IssmDouble     *maxiter          = NULL;
+	IssmDouble *cm_responses     = NULL;
+	IssmDouble *cm_jump          = NULL;
+	IssmDouble *optscal          = NULL;
+	IssmDouble *maxiter          = NULL;
 
 	/*Get parameters: */
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 13975)
@@ -16,5 +16,5 @@
 
 	/*Intermediary*/
-	int i,j,k,n;
+	int i;
 	int dim,materials_type;
 	int numberofelements;
@@ -41,8 +41,8 @@
 	vertices  = new Vertices();
 	materials = new Materials();
-	
+
 	/*First, partition elements and vertices. Nodes will partitioned on a per analysis_type basis. If partitining already done, ignore: */
 	ElementsAndVerticesPartitioning(&iomodel->my_elements,&iomodel->my_vertices,iomodel);
-	
+
 	iomodel->FetchData(2,MeshElementsEnum,MeshElementconnectivityEnum);
 	#ifdef _HAVE_3D_
@@ -50,5 +50,5 @@
 	#endif
 	if(control_analysis)iomodel->FetchData(3,InversionControlParametersEnum,InversionMinParametersEnum,InversionMaxParametersEnum);
-	
+
 	/*Create elements*/
 	for (i=0;i<numberofelements;i++){
@@ -62,5 +62,5 @@
 		}
 	}
-	
+
 	/*Create materials*/
 	switch(materials_type){
@@ -84,5 +84,5 @@
 	/*Add new constant material property to materials, at the end: */
 	materials->AddObject(new Matpar(numberofelements+1,iomodel));//put it at the end of the materials
-	
+
 	/*Create vertices: */
 
@@ -90,10 +90,10 @@
 	iomodel->FetchData(6,MeshElementsEnum,MeshXEnum,MeshYEnum,MeshZEnum,BedEnum,ThicknessEnum);
 	CreateNumberNodeToElementConnectivity(iomodel);
-	
+
 	for (i=0;i<numberofvertices;i++){
 
 		/*vertices and nodes (same number, as we are running continuous galerkin formulation): */
 		if(iomodel->my_vertices[i]){
-			
+
 			/*Add vertex to vertices dataset: */
 			vertices->AddObject(new Vertex(i+1,i,i,iomodel));
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 13975)
@@ -8,5 +8,4 @@
 #error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
-
 
 #include "../../Container/Container.h"
@@ -20,6 +19,6 @@
 
 void CreateParameters(Parameters** pparameters,IoModel* iomodel,char* rootpath,const int solution_type,int analysis_type,int analysis_counter){
-	
-	int         i;
+
+	int         i,j,m,k;
 	int         numoutputs;
 	Parameters *parameters       = NULL;
@@ -27,9 +26,23 @@
 	bool        isdelta18o;
 
+	/*parameters for mass flux: {{{*/
+	int      mass_flux_num_profiles=0;
+	bool     qmu_mass_flux_present=false;
+	bool     autodiff_mass_flux_present=false;
+	bool     mass_flux_present=false;
+	IssmDouble** array=NULL;
+	int*     mdims_array=NULL;
+	int*     ndims_array=NULL;
+	IssmDouble*  temp_matrix=NULL;
+	int      temp_m,temp_n;
+	IssmDouble*  matrix=NULL;
+	int      count;
+	/*}}}*/
+
 	if(*pparameters)return; //do not create parameters twice!
 
 	/*Initialize dataset: */
 	parameters = new Parameters();
-		
+
 	/*Copy some constants from iomodel */
 	parameters->AddObject(iomodel->CopyConstantObject(MeshDimensionEnum));
@@ -127,13 +140,81 @@
 	if(numoutputs)parameters->AddObject(new IntVecParam(DiagnosticRequestedOutputsEnum,requestedoutputs,numoutputs));
 	iomodel->DeleteData(requestedoutputs,DiagnosticRequestedOutputsEnum);
+
 	iomodel->FetchData(&requestedoutputs,&numoutputs,NULL,TransientRequestedOutputsEnum);
 	parameters->AddObject(new IntParam(TransientNumRequestedOutputsEnum,numoutputs));
 	if(numoutputs)parameters->AddObject(new IntVecParam(TransientRequestedOutputsEnum,requestedoutputs,numoutputs));
 	iomodel->DeleteData(requestedoutputs,TransientRequestedOutputsEnum);
+
 	iomodel->FetchData(&requestedoutputs,&numoutputs,NULL,SteadystateRequestedOutputsEnum);
 	parameters->AddObject(new IntParam(SteadystateNumRequestedOutputsEnum,numoutputs));
 	if(numoutputs)parameters->AddObject(new IntVecParam(SteadystateRequestedOutputsEnum,requestedoutputs,numoutputs));
 	iomodel->DeleteData(requestedoutputs,SteadystateRequestedOutputsEnum);
-	
+
+	iomodel->FetchData(&requestedoutputs,&numoutputs,NULL,PrognosticRequestedOutputsEnum);
+	parameters->AddObject(new IntParam(PrognosticNumRequestedOutputsEnum,numoutputs));
+	if(numoutputs)parameters->AddObject(new IntVecParam(PrognosticRequestedOutputsEnum,requestedoutputs,numoutputs));
+	iomodel->DeleteData(requestedoutputs,PrognosticRequestedOutputsEnum);
+
+	/*Deal with mass flux segments: {{{*/
+	iomodel->FetchData(&qmu_mass_flux_present,QmuMassFluxSegmentsPresentEnum);
+	iomodel->FetchData(&autodiff_mass_flux_present,AutodiffMassFluxSegmentsPresentEnum);
+
+	if(qmu_mass_flux_present || autodiff_mass_flux_present)mass_flux_present=true;
+	else mass_flux_present=false;
+	parameters->AddObject(new BoolParam(MassFluxSegmentsPresentEnum,mass_flux_present));
+
+	if(mass_flux_present){
+
+		/*Fetch the mass flux segments necessary to compute the mass fluxes.  Build a DoubleMatArrayParam object out of them: */ 
+		iomodel->FetchData(&array,&mdims_array,&ndims_array,&mass_flux_num_profiles,MassFluxSegmentsEnum);
+		if(mass_flux_num_profiles==0)_error_("mass_flux_num_profiles is 0, when MassFlux computations were requested!");
+
+		/*Go through segments, and extract those that belong to this cpu: */
+		for(i=0;i<mass_flux_num_profiles;i++){
+			temp_matrix=array[i];
+			temp_m=mdims_array[i];
+			temp_n=ndims_array[i];
+
+			m=0;
+			for(j=0;j<temp_m;j++){
+				if (  iomodel->my_elements[reCast<int>(*(temp_matrix+5*j+4))-1] )m++;
+			}
+			if(m){
+				matrix=xNewZeroInit<IssmDouble>(5*m);
+				count=0;
+				for(j=0;j<temp_m;j++){
+					if (iomodel->my_elements[reCast<int>(*(temp_matrix+5*j+4))-1]){
+						for(k=0;k<5;k++)*(matrix+5*count+k)=*(temp_matrix+5*j+k);
+						count++;
+					}
+				}
+			}
+			else{
+				matrix=NULL;
+			}
+
+			/*Assign: */
+			array[i]=matrix;
+			mdims_array[i]=m;
+			ndims_array[i]=5;
+
+			/*Free temporary matrix: */
+			xDelete<IssmDouble>(temp_matrix);
+		}
+
+		/*Ok, we have an array of segments, different on every cpu. Create a DoubleMatArrayParam object with it: */
+		parameters->AddObject(new DoubleMatArrayParam(MassFluxSegmentsEnum,array,mass_flux_num_profiles,mdims_array,ndims_array));
+
+		/*Free data: */
+		for(i=0;i<mass_flux_num_profiles;i++){
+			IssmDouble* matrix=array[i];
+			xDelete<IssmDouble>(matrix);
+		}
+		xDelete<int>(mdims_array); 
+		xDelete<int>(ndims_array);
+		xDelete<IssmDouble*>(array);
+	}
+	/*}}}*/
+
 	/*Before returning, create parameters in case we are running Qmu or control types runs: */
 	#ifdef _HAVE_CONTROL_
